/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15Fxx ϵ ڲEEPROM------------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

typedef bit BOOL;
typedef unsigned char BYTE;
typedef unsigned int WORD;

//-----------------------------------------------

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr IAP_DATA    =   0xC2;               //IAPݼĴ
sfr IAP_ADDRH   =   0xC3;               //IAPַĴֽ
sfr IAP_ADDRL   =   0xC4;               //IAPַĴֽ
sfr IAP_CMD     =   0xC5;               //IAPĴ
sfr IAP_TRIG    =   0xC6;               //IAPĴ
sfr IAP_CONTR   =   0xC7;               //IAPƼĴ

#define CMD_IDLE    0                   //ģʽ
#define CMD_READ    1                   //IAPֽڶ
#define CMD_PROGRAM 2                   //IAPֽڱ
#define CMD_ERASE   3                   //IAP

//#define ENABLE_IAP 0x80               //if SYSCLK<30MHz
//#define ENABLE_IAP 0x81               //if SYSCLK<24MHz
#define ENABLE_IAP  0x82                //if SYSCLK<20MHz
//#define ENABLE_IAP 0x83               //if SYSCLK<12MHz
//#define ENABLE_IAP 0x84               //if SYSCLK<6MHz
//#define ENABLE_IAP 0x85               //if SYSCLK<3MHz
//#define ENABLE_IAP 0x86               //if SYSCLK<2MHz
//#define ENABLE_IAP 0x87               //if SYSCLK<1MHz

//Եַ
#define IAP_ADDRESS 0x0400

sfr AUXR = 0x8E;
sbit RXB = P3^0;                        //define UART TX/RX port
sbit TXB = P3^1;

//-----------------------------------------
//define baudrate const
//BAUD = 65536 - FOSC/3/BAUDRATE/M (1T:M=1; 12T:M=12)
//NOTE: (FOSC/3/BAUDRATE) must be greater then 98, (RECOMMEND GREATER THEN 110)

//#define BAUD  0xF400                  // 1200bps @ 11.0592MHz
//#define BAUD  0xFA00                  // 2400bps @ 11.0592MHz
//#define BAUD  0xFD00                  // 4800bps @ 11.0592MHz
//#define BAUD  0xFE80                  // 9600bps @ 11.0592MHz
//#define BAUD  0xFF40                  //19200bps @ 11.0592MHz
#define   BAUD  0xFFA0                  //38400bps @ 11.0592MHz

//#define BAUD  0xEC00                  // 1200bps @ 18.432MHz
//#define BAUD  0xF600                  // 2400bps @ 18.432MHz
//#define BAUD  0xFB00                  // 4800bps @ 18.432MHz
//#define BAUD  0xFD80                  // 9600bps @ 18.432MHz
//#define BAUD  0xFEC0                  //19200bps @ 18.432MHz
//#define BAUD  0xFF60                  //38400bps @ 18.432MHz

//#define BAUD  0xE800                  // 1200bps @ 22.1184MHz
//#define BAUD  0xF400                  // 2400bps @ 22.1184MHz
//#define BAUD  0xFA00                  // 4800bps @ 22.1184MHz
//#define BAUD  0xFD00                  // 9600bps @ 22.1184MHz
//#define BAUD  0xFE80                  //19200bps @ 22.1184MHz
//#define BAUD  0xFF40                  //38400bps @ 22.1184MHz
//#define BAUD  0xFF80                  //57600bps @ 22.1184MHz

BYTE TBUF,RBUF;
BYTE TDAT,RDAT;
BYTE TCNT,RCNT;
BYTE TBIT,RBIT;
BOOL TING,RING;
BOOL TEND,REND;

void UART_INIT();
BYTE UART_SEND(BYTE dat);

void Delay(BYTE n);
void IapIdle();
BYTE IapReadByte(WORD addr);
void IapProgramByte(WORD addr, BYTE dat);
void IapEraseSector(WORD addr);

BYTE t, r;
BYTE buf[16];

void main()
{
    WORD i;

    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    P1 = 0xfe;                      //1111,1110 ϵͳOK
    UART_INIT();                    //ʼ
    Delay(10);                      //ʱ
    IapEraseSector(IAP_ADDRESS);    //
    for (i=0; i<512; i++)           //Ƿɹ(ȫFF)
    {
        if (UART_SEND(IapReadByte(IAP_ADDRESS+i)) != 0xff)
            goto Error;             //,˳
    }
    P1 = 0xfc;                      //1111,1100 ɹ
    Delay(10);                      //ʱ
    for (i=0; i<512; i++)           //512ֽ
    {
        IapProgramByte(IAP_ADDRESS+i, (BYTE)i);
    }
    P1 = 0xf8;                      //1111,1000 
    Delay(10);                      //ʱ
    for (i=0; i<512; i++)           //У512ֽ
    {
        if (UART_SEND(IapReadByte(IAP_ADDRESS+i)) != (BYTE)i)
            goto Error;             //У,˳
    }
    P1 = 0xf0;                      //1111,0000 
    while (1);
Error:
    P1 &= 0x7f;                     //0xxx,xxxx IAPʧ
    
    while (1);
}

//-----------------------------------------
//Timer interrupt routine for UART

void tm0() interrupt 1 using 1
{
    if (RING)
    {
        if (--RCNT == 0)
        {
            RCNT = 3;                   //reset send baudrate counter
            if (--RBIT == 0)
            {
                RBUF = RDAT;            //save the data to RBUF
                RING = 0;               //stop receive
                REND = 1;               //set receive completed flag
            }
            else
            {
                RDAT >>= 1;
                if (RXB) RDAT |= 0x80;  //shift RX data to RX buffer
            }
        }
    }
    else if (!RXB)
    {
        RING = 1;                       //set start receive flag
        RCNT = 4;                       //initial receive baudrate counter
        RBIT = 9;                       //initial receive bit number (8 data bits + 1 stop bit)
    }

    if (--TCNT == 0)
    {
        TCNT = 3;                       //reset send baudrate counter
        if (TING)                       //judge whether sending
        {
            if (TBIT == 0)
            {
                TXB = 0;                //send start bit
                TDAT = TBUF;            //load data from TBUF to TDAT
                TBIT = 9;               //initial send bit number (8 data bits + 1 stop bit)
            }
            else
            {
                TDAT >>= 1;             //shift data to CY
                if (--TBIT == 0)
                {
                    TXB = 1;
                    TING = 0;           //stop send
                    TEND = 1;           //set send completed flag
                }
                else
                {
                    TXB = CY;           //write CY to TX port
                }
            }
        }
    }
}

//-----------------------------------------
//initial UART module variable

void UART_INIT()
{
    TING = 0;
    RING = 0;
    TEND = 1;
    REND = 0;
    TCNT = 0;
    RCNT = 0;
}

//-----------------------------------------
//Send UART data

BYTE UART_SEND(BYTE dat)
{
    while (!TEND);
    TEND = 0;
    TBUF = dat;
    TING = 1;
    
    return dat;
}

/*----------------------------
رIAP
----------------------------*/
void IapIdle()
{
    IAP_CONTR = 0;                  //رIAP
    IAP_CMD = 0;                    //Ĵ
    IAP_TRIG = 0;                   //Ĵ
    IAP_ADDRH = 0x80;               //ַõIAP
    IAP_ADDRL = 0;
}

/*----------------------------
ISP/IAP/EEPROMȡһֽ
----------------------------*/
BYTE IapReadByte(WORD addr)
{
    BYTE dat;                       //ݻ

    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_READ;             //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    dat = IAP_DATA;                 //ISP/IAP/EEPROM
    IapIdle();                      //رIAP

    return dat;                     //
}

/*----------------------------
дһֽݵISP/IAP/EEPROM
----------------------------*/
void IapProgramByte(WORD addr, BYTE dat)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_PROGRAM;          //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_DATA = dat;                 //дISP/IAP/EEPROM
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    IapIdle();
}

/*----------------------------

----------------------------*/
void IapEraseSector(WORD addr)
{
    IAP_CONTR = ENABLE_IAP;         //ʹIAP
    IAP_CMD = CMD_ERASE;            //IAP
    IAP_ADDRL = addr;               //IAP͵ַ
    IAP_ADDRH = addr >> 8;          //IAPߵַ
    IAP_TRIG = 0x5a;                //д(0x5a)
    IAP_TRIG = 0xa5;                //д(0xa5)
    _nop_();                        //ȴISP/IAP/EEPROM
    IapIdle();
}

/*----------------------------
ʱ
----------------------------*/
void Delay(BYTE n)
{
    WORD x;

    while (n--)
    {
        x = 0;
        while (++x);
    }
}

