
/*------------------------------------------------------------------*/
/* --- STC MCU International Limited -------------------------------*/
/* --- STC 1T Series MCU Programme Demo ----------------------------*/
/* --- Fax: 86-755-82944243 ----------------------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966----------------------*/
/* --- Web: www.STCMCU.com -----------------------------------------*/
/* --- Web: www.GXWMCU.com -----------------------------------------*/
/* If you want to use the program or the program referenced in the  */
/* article, please specify in which data and procedures from STC    */
/*------------------------------------------------------------------*/

/*      򾭹ȫ, ṩ绰֧, 粻, вػ.  */

/*
 : ʹSTCڴPCA9~16λPWMPWMn.hѡSTC12C5201ADϵлSTC12C5A60S2ϵС
                 ԭ˵
ʾһЩӦҪĸ8λֱʵ9~16λPWM8λPWMֱʹSTCӲPWMοйصĵ(Datasheet)
ӦҪԴPCAɱ̼УĴƥж
õ16λ:
PWM_high  PWMߵƽPCAʱ
PWM_low   PWM͵ƽPCAʱ
PWM = PWM_HIGH + PWM_LOW
PCAʱԴ8ѡ
PCAģ鱻Ϊ16λʽPCAֵ벶ĴֵƥʱCCP0ȡͬʱȽƥжϡ
ȽƥжжϸĵƽǸߵƽ򲶻ĴװߵƽPCAʱǵ͵ƽװ͵ƽPCAʱ
жϴҪһʱ䣬ռձȲܵ0%100%ԶPWM_highСֵжϴʱԼΪ100SYSCLK

ʾĲǻ¼裺
PCAʱźΪϵͳʱFoscPCAжȼΪߡ
ʾжϷܳʱʱпܻӰ챾С

ʾû"ûú"ѡ²
PCA_IDLE_DISABLE    IDLEģʽǷֹPCAѡ1: MCUIDLEģʽʱֹPCA  ѡ0:  MCUIDLEģʽʱPCA
PCA_SOURCE_SELECT   ѡPCAĻ׼ʱԴʾʹϵͳʱFoscPCAʱԴ
PWM_DUTY            PWMڣֵΪPCAѡʱûֻҪװPWM_highPWM_lowǸڼġ
PWM_HIGH_MAX        PWMռձȣԭǰװPWM_highڴֵش
PWM_HIGH_MIN        PWMСռձȣԭǰװPWM_highСڴֵش
*/

#include "reg51.h"

#define     MAIN_Fosc   24576000L   //ʱ

#define     PCA_IDLE_DISABLE    0           //1: MCUIDLEģʽʱֹPCA   0:  MCUIDLEģʽʱPCA
#define     PCA_SOURCE_SELECT   4           //ѡPCAĻ׼ʱԴ
                                            //0ϵͳʱFosc/12
                                            //1ϵͳʱFosc/2
                                            //2ʱ0
                                            //3ECI/P3.4ŵⲿʱ루=Fosc/2
                                            //4ϵͳʱFosc
                                            //5ϵͳʱFosc/4
                                            //6ϵͳʱFosc/6
                                            //7ϵͳʱFosc/8
#define     PWM_DUTY        4096            //PWMڣֵΪPCAѡʱ


/**********************************************************************************************************/


sfr P_SW1       = 0xA2;                     //蹦лĴ1

#define CCP_S0 0x10                         //P_SW1.4
#define CCP_S1 0x20                         //P_SW1.5

sfr CCON        =   0xD8;                   //PCAƼĴ
sbit CCF0       =   CCON^0;                 //PCAģ0жϱ־
sbit CCF1       =   CCON^1;                 //PCAģ1жϱ־
sbit CR         =   CCON^6;                 //PCAʱпλ
sbit CF         =   CCON^7;                 //PCAʱ־
sfr CMOD        =   0xD9;                   //PCAģʽĴ
sfr CL          =   0xE9;                   //PCAʱֽ
sfr CH          =   0xF9;                   //PCAʱֽ
sfr CCAPM0      =   0xDA;                   //PCAģ0ģʽĴ
sfr CCAP0L      =   0xEA;                   //PCAģ0Ĵ LOW
sfr CCAP0H      =   0xFA;                   //PCAģ0Ĵ HIGH
sfr CCAPM1      =   0xDB;                   //PCAģ1ģʽĴ
sfr CCAP1L      =   0xEB;                   //PCAģ1Ĵ LOW
sfr CCAP1H      =   0xFB;                   //PCAģ1Ĵ HIGH
sfr CCAPM2      =   0xDC;                   //PCAģ2ģʽĴ
sfr CCAP2L      =   0xEC;                   //PCAģ2Ĵ LOW
sfr CCAP2H      =   0xFC;                   //PCAģ2Ĵ HIGH
sfr PCA_PWM0    =   0xf2;                   //PCAģ0PWMĴ
sfr PCA_PWM1    =   0xf3;                   //PCAģ1PWMĴ
sfr PCA_PWM2    =   0xf4;                   //PCAģ2PWMĴ

sfr P1M0        =   0x92;
sfr P1M1        =   0x91;

sbit  CCP0      =   P1^1;
sbit  CCP1      =   P1^0;

#define     PWM_HIGH_MAX    PWM_DUTY-32     //PWMռձȡ
#define     PWM_HIGH_MIN        32          //PWMСռձȡ

/*************  ر    **************/
unsigned int    pwm;        //ûPWM

/*************  غ    **************/
void  delay_ms(unsigned char ms);



/****************  ⲿⲿ *****************/
extern unsigned int PWM_high;               //PWMձȼĴPWMߵƽPCAʱռձд
void PWMn_SetHighReg(unsigned int high);
void PWMn_init(unsigned int high);


/********************  **************************/
//========================================================================
// : void main(void)
// : ϸPWMֵʾ۲ռձȱ仯
// : ޡ
// : ޡ
// 汾: VER1.0
// : 2011-4-11
// ע:
//========================================================================
void main(void)
{
    pwm = 1000;                             //pwmֵ
    pwm = PWM_HIGH_MIN;                     //pwmֵ
    PWMn_init(pwm); //ʼpwm

    while (1)
    {
        delay_ms(10);   //ʱ
        pwm += 10;
        if(pwm >= PWM_HIGH_MAX) pwm = PWM_HIGH_MIN;
        PWMn_SetHighReg(pwm);               //PWMռձ
    }
}
/**********************************************/


//========================================================================
// : void  delay_ms(unsigned char ms)
// : ʱ
// : ms,Ҫʱms.
// : none.
// 汾: VER1.0
// : 2010-12-15
// ע:
//========================================================================
void  delay_ms(unsigned char ms)
{
     unsigned int i;
     do
     {
        i = MAIN_Fosc / 14000L; //1T
        while(--i)  ;
     }while(--ms);
}

unsigned int    PWM_high;                   //PWMռձȼĴPWMߵƽPCAʱռձд
unsigned int    PWM_low;                    //PWM͵ƽPCAʱ
unsigned int    CCAP0_tmp;                  //CCAP0װӰĴ

//========================================================================
// : void PWMn_SetHighReg(unsigned int high)
// : дռձݡ
// : high:  ռձݣPWMߵƽPCAʱ
// : 
// 汾: VER1.0
// : 2009-12-30
// ע:
//========================================================================
void PWMn_SetHighReg(unsigned int high)
{
    if(high > PWM_HIGH_MAX)     high = PWM_HIGH_MAX;    //дռձݣǿΪռձȡ
    if(high < PWM_HIGH_MIN)     high = PWM_HIGH_MIN;    //дССռձݣ򷵻ش2
    CR = 0;                     //ֹͣPCA
    PWM_high = high;                        //ȷΧװռձȼĴ
    PWM_low = PWM_DUTY - high;              //㲢PWM͵ƽPCAʱ
    CR = 1;                     //PCA
}

//========================================================================
// : void PWMn_init(unsigned int high)
// : ʼ
// : high:  ʼռձݣPWMߵƽPCAʱ
// : 
// 汾: VER1.0
// : 2009-12-30
// ע:
//========================================================================
void PWMn_init(unsigned int high)
{
    ACC = P_SW1;
    ACC &= ~(CCP_S0 | CCP_S1);              //CCP_S0=0 CCP_S1=0
    P_SW1 = ACC;                            //(P1.2/ECI, P1.1/CCP0, P1.0/CCP1, P3.7/CCP2)

//  ACC = P_SW1;
//  ACC &= ~(CCP_S0 | CCP_S1);              //CCP_S0=1 CCP_S1=0
//  ACC |= CCP_S0;                          //(P3.4/ECI_2, P3.5/CCP0_2, P3.6/CCP1_2, P3.7/CCP2_2)
//  P_SW1 = ACC;
//
//  ACC = P_SW1;
//  ACC &= ~(CCP_S0 | CCP_S1);              //CCP_S0=0 CCP_S1=1
//  ACC |= CCP_S1;                          //(P2.4/ECI_3, P2.5/CCP0_3, P2.6/CCP1_3, P2.7/CCP2_3)
//  P_SW1 = ACC;

    P1M1 &= ~0x02,  P1M0 |=  0x02;          //CCAP0ʹPUSH-PULLģʽ
    CCON = 0;                               //CFCRCCF0CCF1
    CMOD = (PCA_IDLE_DISABLE << 7) | (PCA_SOURCE_SELECT << 1);  //ʼPCAģʽĴPWMn.hѡ
    CCAPM0 = 0x4D;                          //ģʽȽƥж(ECCF0=1)
    CL = 0;                                 //PCA
    CH = 0;
    CCAP0_tmp = 0;                          //CCAP0װӰĴ
    PWMn_SetHighReg(high);                  //ʼռձݡ
    CR = 1;                                 //PCA
    EA = 1;                                 //ж
}

//========================================================================
// : void PCA_interrupt (void) interrupt 7
// : PCAжϷ
// : ޡ
// : ޡ
// 汾: VER1.0
// : 2009-12-30
// ע:
//========================================================================
void PCA_interrupt (void) interrupt 7
{
    if(CCF0 == 1)       //PCAģ0ж
    {
        CCF0 = 0;       //PCAģ0жϱ־

        if(CCP0 == 1)   CCAP0_tmp += PWM_high;      //ΪߵƽӰĴװظߵƽʱ䳤
        else            CCAP0_tmp += PWM_low;       //Ϊ͵ƽӰĴװص͵ƽʱ䳤
        CCAP0L = (unsigned char)CCAP0_tmp;          //ӰĴд벶ĴдCCAP0L
        CCAP0H = (unsigned char)(CCAP0_tmp >> 8);   //дCCAP0H
    }
/*
    else if(CCF1 == 1)                         //PCAģ1ж
    {
        CCF1 = 0;                              //PCAģ1жϱ־
    }
    else if(CF == 1)                           //PCAж
    {
        CF = 0;                                //PCAжϱ־
    }
*/
}

