/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ 1ַԶʶ---------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

typedef unsigned char BYTE;
typedef unsigned int WORD;

//-----------------------------------------------

#define     SLAVE   1               //ӻ,0Ϊӻ1, 1Ϊӻ2

#if SLAVE == 0
#define     SAMASK  0x33            //ӻ1ַλ
#define     SERADR  0x55            //ӻ1ĵַΪxx01,xx01
#define     ACKTST  0x78            //ӻ1Ӧ
#else
#define     SAMASK  0x3C            //ӻ2ַλ
#define     SERADR  0x5A            //ӻ2ĵַΪxx01,10xx
#define     ACKTST  0x49            //ӻ2Ӧ
#endif

#define     URMD    2               //0:ʹöʱ2Ϊʷ
                                    //1:ʹöʱ1ģʽ0(16λԶģʽ)Ϊʷ
                                    //2:ʹöʱ1ģʽ2(8λԶģʽ)Ϊʷ

sfr T2H   =   0xd6;                 //ʱ28λ
sfr T2L   =   0xd7;                 //ʱ28λ

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr AUXR  =   0x8e;                 //Ĵ                              

sfr SADDR =   0xA9;                 //ӻַĴ
sfr SADEN =   0xB9;                 //ӻַμĴ

void InitUart();

char count;

void main()
{
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    InitUart();                     //ʼ
    ES = 1;
    EA = 1;
    while (1);
}

/*----------------------------
UART жϷ
-----------------------------*/
void Uart() interrupt 4 using 1
{
    if (TI)
    {
        TI = 0;                     //TIλ
        if (count != 0)
        {
            count--;
            SBUF = ACKTST;          //Ӧ
        }
        else
        {
            SM2 = 1;                //,¿ʼַ
        }
    }
    if (RI)
    {
        RI = 0;                     //RIλ
        SM2 = 0;                    //ѡк,ݽ״̬
        count = 7;
        SBUF = ACKTST;              //Ӧ
    }
}

/*----------------------------
ʼ
----------------------------*/
void InitUart()
{
    SADDR = SERADR;
    SADEN = SAMASK;
    SCON = 0xf8;                //ôΪ9λɱ䲨,ʹܶͨѶ,(TB8Ϊ1,PCֱͨѶ)
#if URMD == 0
    T2L = 0xd8;                 //òװֵ
    T2H = 0xff;                 //115200 bps(65536-18432000/4/115200)
    AUXR = 0x14;                //T2Ϊ1Tģʽ, ʱ2
    AUXR |= 0x01;               //ѡʱ2Ϊ1Ĳʷ
#elif URMD == 1
    AUXR = 0x40;                //ʱ1Ϊ1Tģʽ
    TMOD = 0x00;                //ʱ1Ϊģʽ0(16λԶ)
    TL1 = 0xd8;                 //òװֵ
    TH1 = 0xff;                 //115200 bps(65536-18432000/4/115200)
    TR1 = 1;                    //ʱ1ʼ
#else
    TMOD = 0x20;                //öʱ1Ϊ8λԶװģʽ
    AUXR = 0x40;                //ʱ1Ϊ1Tģʽ
    TH1 = TL1 = 0xfb;           //115200 bps(256 - 18432000/32/115200)
    TR1 = 1;
#endif
}

