/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ ʱ22Ĳʷ------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

typedef unsigned char BYTE;
typedef unsigned int WORD;

#define FOSC 11059200L          //ϵͳƵ
#define BAUD 115200             //ڲ

#define NONE_PARITY     0       //У
#define ODD_PARITY      1       //У
#define EVEN_PARITY     2       //żУ
#define MARK_PARITY     3       //У
#define SPACE_PARITY    4       //հУ

#define PARITYBIT EVEN_PARITY   //Уλ

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr AUXR  = 0x8e;               //Ĵ
sfr S2CON = 0x9a;               //UART2 ƼĴ
sfr S2BUF = 0x9b;               //UART2 ݼĴ
sfr T2H   = 0xd6;               //ʱ28λ
sfr T2L   = 0xd7;               //ʱ28λ
sfr IE2   = 0xaf;               //жϿƼĴ2

#define S2RI  0x01              //S2CON.0
#define S2TI  0x02              //S2CON.1
#define S2RB8 0x04              //S2CON.2
#define S2TB8 0x08              //S2CON.3

sfr P_SW2   = 0xBA;             //蹦лĴ2
#define S2_S0 0x01              //P_SW2.0

bit busy;

void SendData(BYTE dat);
void SendString(char *s);

void main()
{
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    P_SW2 &= ~S2_S0;            //S2_S0=0 (P1.0/RxD2, P1.1/TxD2)
//  P_SW2 |= S2_S0;             //S2_S0=1 (P4.6/RxD2_2, P4.7/TxD2_2)

#if (PARITYBIT == NONE_PARITY)
    S2CON = 0x50;               //8λɱ䲨
#elif (PARITYBIT == ODD_PARITY) || (PARITYBIT == EVEN_PARITY) || (PARITYBIT == MARK_PARITY)
    S2CON = 0xda;               //9λɱ䲨,УλʼΪ1
#elif (PARITYBIT == SPACE_PARITY)
    S2CON = 0xd2;               //9λɱ䲨,УλʼΪ0
#endif

    T2L = (65536 - (FOSC/4/BAUD));   //òװֵ
    T2H = (65536 - (FOSC/4/BAUD))>>8;
    AUXR = 0x14;                //T2Ϊ1Tģʽ, ʱ2
    IE2 = 0x01;                 //ʹܴ2ж
    EA = 1;

    SendString("STC15F2K60S2\r\nUart2 Test !\r\n");
    while(1);
}

/*----------------------------
UART2 жϷ
-----------------------------*/
void Uart2() interrupt 8 using 1
{
    if (S2CON & S2RI)
    {
        S2CON &= ~S2RI;         //S2RIλ
        P0 = S2BUF;             //P0ʾ
        P2 = (S2CON & S2RB8);   //P2.2ʾУλ
    }
    if (S2CON & S2TI)
    {
        S2CON &= ~S2TI;         //S2TIλ
        busy = 0;               //æ־
    }
}

/*----------------------------
ʹ
----------------------------*/
void SendData(BYTE dat)
{
    while (busy);               //ȴǰݷ
    ACC = dat;                  //ȡУλP (PSW.0)
    if (P)                      //PУλ
    {
#if (PARITYBIT == ODD_PARITY)
        S2CON &= ~S2TB8;        //УλΪ0
#elif (PARITYBIT == EVEN_PARITY)
        S2CON |= S2TB8;         //УλΪ1
#endif
    }
    else
    {
#if (PARITYBIT == ODD_PARITY)
        S2CON |= S2TB8;         //УλΪ1
#elif (PARITYBIT == EVEN_PARITY)
        S2CON &= ~S2TB8;        //УλΪ0
#endif
    }
    busy = 1;
    S2BUF = ACC;                //дݵUART2ݼĴ
}

/*----------------------------
ַ
----------------------------*/
void SendString(char *s)
{
    while (*s)                  //ַ־
    {
        SendData(*s++);         //͵ǰַ
    }
}

