/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 ϵ ʱ33Ĳʷ------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/* ҪӦô˴,עʹSTCϼ        */
/*---------------------------------------------------------------------*/

//ʾKeilѡIntel8058оƬͺŽб
//ر˵,ƵһΪ11.0592MHz


#include "reg51.h"
#include "intrins.h"

typedef unsigned char BYTE;
typedef unsigned int WORD;

#define FOSC 11059200L          //ϵͳƵ
#define BAUD 115200             //ڲ

#define NONE_PARITY     0       //У
#define ODD_PARITY      1       //У
#define EVEN_PARITY     2       //żУ
#define MARK_PARITY     3       //У
#define SPACE_PARITY    4       //հУ

#define PARITYBIT EVEN_PARITY   //Уλ

sfr P0M1 = 0x93;
sfr P0M0 = 0x94;
sfr P1M1 = 0x91;
sfr P1M0 = 0x92;
sfr P2M1 = 0x95;
sfr P2M0 = 0x96;
sfr P3M1 = 0xb1;
sfr P3M0 = 0xb2;
sfr P4M1 = 0xb3;
sfr P4M0 = 0xb4;
sfr P5M1 = 0xC9;
sfr P5M0 = 0xCA;
sfr P6M1 = 0xCB;
sfr P6M0 = 0xCC;
sfr P7M1 = 0xE1;
sfr P7M0 = 0xE2;

sfr S3CON = 0xac;               //UART3 ƼĴ
sfr S3BUF = 0xad;               //UART3 ݼĴ

sfr IE2     = 0xAF;             //жʹܼĴ2
sfr T4T3M   = 0xD1;             //ʱ3Ͷʱ4ƼĴ
sfr T4H     = 0xD2;             //ʱ48λ
sfr T4L     = 0xD3;             //ʱ48λ
sfr T3H     = 0xD4;             //ʱ38λ
sfr T3L     = 0xD5;             //ʱ38λ

#define S3RI  0x01              //S3CON.0
#define S3TI  0x02              //S3CON.1
#define S3RB8 0x04              //S3CON.2
#define S3TB8 0x08              //S3CON.3

sfr P_SW2   = 0xBA;             //蹦лĴ2
#define S3_S0 0x02              //P_SW2.1

bit busy;

void SendData(BYTE dat);
void SendString(char *s);

void main()
{
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    P6M0 = 0x00;
    P6M1 = 0x00;
    P7M0 = 0x00;
    P7M1 = 0x00;

    P_SW2 &= ~S3_S0;            //S3_S0=0 (P0.0/RxD3, P0.1/TxD3)
//  P_SW2 |= S3_S0;             //S3_S0=1 (P5.0/RxD3_2, P5.1/TxD3_2)

#if (PARITYBIT == NONE_PARITY)
    S3CON = 0x50;               //8λɱ䲨
#elif (PARITYBIT == ODD_PARITY) || (PARITYBIT == EVEN_PARITY) || (PARITYBIT == MARK_PARITY)
    S3CON = 0xda;               //9λɱ䲨,УλʼΪ1
#elif (PARITYBIT == SPACE_PARITY)
    S3CON = 0xd2;               //9λɱ䲨,УλʼΪ0
#endif

    T3L = (65536 - (FOSC/4/BAUD));   //òװֵ
    T3H = (65536 - (FOSC/4/BAUD))>>8;
    T4T3M |= 0x02;              //ʱ3Ϊ1Tģʽ
    T4T3M |= 0x08;              //ʱ3ʼʱ
    IE2 = 0x08;                 //ʹܴ3ж
    EA = 1;

    SendString("STC15F4K60S4\r\nUart3 Test !\r\n");
    while(1);
}

/*----------------------------
UART3 жϷ
-----------------------------*/
void Uart3() interrupt 17 using 1
{
    if (S3CON & S3RI)
    {
        S3CON &= ~S3RI;         //S3RIλ
        P0 = S3BUF;             //P0ʾ
        P2 = (S3CON & S3RB8);   //P2.2ʾУλ
    }
    if (S3CON & S3TI)
    {
        S3CON &= ~S3TI;         //S3TIλ
        busy = 0;               //æ־
    }
}

/*----------------------------
ʹ
----------------------------*/
void SendData(BYTE dat)
{
    while (busy);               //ȴǰݷ
    ACC = dat;                  //ȡУλP (PSW.0)
    if (P)                      //PУλ
    {
#if (PARITYBIT == ODD_PARITY)
        S3CON &= ~S3TB8;        //УλΪ0
#elif (PARITYBIT == EVEN_PARITY)
        S3CON |= S3TB8;         //УλΪ1
#endif
    }
    else
    {
#if (PARITYBIT == ODD_PARITY)
        S3CON |= S3TB8;         //УλΪ1
#elif (PARITYBIT == EVEN_PARITY)
        S3CON &= ~S3TB8;        //УλΪ0
#endif
    }
    busy = 1;
    S3BUF = ACC;                //дݵUART2ݼĴ
}

/*----------------------------
ַ
----------------------------*/
void SendString(char *s)
{
    while (*s)                  //ַ־
    {
        SendData(*s++);         //͵ǰַ
    }
}

